using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Tools;

namespace SyncTabEx
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{

		#region Members

		private Syncfusion.Windows.Forms.Tools.TabControlAdv tabControlAdv1;
		private System.Windows.Forms.Button btnAddTab;
	    private static int NumberOfTabs;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		#endregion Members

		#region Delegates
		private delegate void CreateNewTabEvent();
		private event CreateNewTabEvent createNewTabEvent = null;
		#endregion Delegates

		#region Nested Classes
		public class PTabPage: TabPageAdv
		{
			public PTabPage(string text)
			{
				this.Text = text;
			}
		}
		#endregion Nested Classes
		#region Ctor
		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			this.RegisterEvents();
			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			this.UnregisterEvents();

			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#endregion Ctror

		#region Register\Unregister Events
		public void RegisterEvents()
		{
			this.createNewTabEvent += new CreateNewTabEvent(Form1_createNewTabEvent);
		}
		public void UnregisterEvents()
		{
			this.createNewTabEvent -= new CreateNewTabEvent(Form1_createNewTabEvent);
		}
		#endregion Register\Unregister Events

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.tabControlAdv1 = new Syncfusion.Windows.Forms.Tools.TabControlAdv();
			this.btnAddTab = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.tabControlAdv1)).BeginInit();
			this.SuspendLayout();
			// 
			// tabControlAdv1
			// 
			this.tabControlAdv1.Location = new System.Drawing.Point(16, 24);
			this.tabControlAdv1.Name = "tabControlAdv1";
			this.tabControlAdv1.Size = new System.Drawing.Size(704, 48);
			this.tabControlAdv1.TabIndex = 0;
			// 
			// btnAddTab
			// 
			this.btnAddTab.Location = new System.Drawing.Point(264, 400);
			this.btnAddTab.Name = "btnAddTab";
			this.btnAddTab.TabIndex = 1;
			this.btnAddTab.Text = "Add Tab";
			this.btnAddTab.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(728, 502);
			this.Controls.Add(this.btnAddTab);
			this.Controls.Add(this.tabControlAdv1);
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.tabControlAdv1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			if( this.createNewTabEvent != null )
			{
				this.createNewTabEvent.BeginInvoke(null, null);
			}
		}

		private void Form1_createNewTabEvent()
		{
			NumberOfTabs++;
			PTabPage newTab = new PTabPage( "Tab" + NumberOfTabs.ToString() );
			this.tabControlAdv1.Controls.Add( newTab );
			this.tabControlAdv1.SelectedTab = newTab; 
		}
	}
}
